##############################################################################
#
# Copyright (c) 2003 gocept gmbh & co. kg. All rights reserved.
#
# See also LICENSE.txt
#
##############################################################################
"""CMF link checker tool
$Id: Install.py,v 1.1 2004/01/15 16:07:50 ctheune Exp $"""

from Products.CMFLinkChecker.LinkCheckerTool import LinkCheckerTool
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFLinkChecker import linkchecker_globals 
from StringIO import StringIO
import string

from Products.CMFFormController.globalVars import ANY_BUTTON, ANY_CONTEXT

def install(self):
    out=StringIO()

    if not hasattr(self, "_isPortalRoot"):
        print >> out, "Must be installed in a CMF Site (read Plone)"
        return
   
    print >> out, 'Installing portal_linkchecker'

    self.portal_actions.manage_aproviders(apname="portal_linkchecker", add_provider=1, REQUEST=None)
    self.manage_addProduct['CMFLinkChecker'].manage_addTool(type='CMF Linkchecker Tool')

    self.portal_catalog.addIndex("portal_linkchecker_uid", "FieldIndex")
    self.left_slots = list(self.left_slots) + ['here/portlet_links/macros/portlet',]

    # XXX Register with form validation

    # Register configlet
    portal_conf=getToolByName(self,'portal_controlpanel')
    portal_conf.registerConfiglet( 'CMFLinkChecker'
                 , 'LinkChecker'      
                 , 'string:${portal_url}/lc_configlet' 
                 , ''                   # a condition   
                 , 'Manage portal'      # access permission
                 , 'Products'           # section to which the configlet should be added: 
                                        #(Plone,Products,Members) 
                 , 1                    # visibility
                 , 'CMFLinkChecker'
                 , 'linkchecker.png' # icon in control_panel, put your own icon in the 
                                                # /skins folder of your product and change 
                                                #'site_icon.gif' to 'yourfile'
                 , 'An utility for monitoring external links in your site. Helps you to avoid dead links.'
                 , None
                 )  

    portal_conf.registerConfiglet( 'MemberLinkChecker'
                 , 'Link monitoring settings'      
                 , 'string:${portal_url}/lc_personalize_form' 
                 , ''                   # a condition   
                 , 'Set own properties'      # access permission
                 , 'Member'   
                 , 1         
                 , 'CMFLinkChecker'
                 , 'linkchecker.png' # icon in control_panel, put your own icon in the 
                                                # /skins folder of your product and change 
                                                #'site_icon.gif' to 'yourfile'
                 , 'An utility for monitoring external links in your site. Helps you to avoid dead links.'
                 , None
                 )  

    # Register skins
    addDirectoryViews(self.portal_skins, 'skins', linkchecker_globals)
    skins = self.portal_skins.getSkinSelections()
    for skin in skins:
        path = self.portal_skins.getSkinPath(skin)
        path = map(string.strip, path.split(','))
        if 'linkchecker' not in path:
            try:
                    path.insert(path.index('content'), 'linkchecker')
            except ValueError:
                    path.append('linkchecker')
            path = ','.join(path)
            self.portal_skins.addSkinSelection(skin, path)
            print >> out, skin + ",",
        else:
            print >> out, "skipped" + skin,

    # Update memberproperties schema
    memberdata = getToolByName(self, "portal_memberdata")
    self._setProperty("lc_status", "", "lines")
    self.lc_status = ("red", "orange", "grey", "green",)
    self._setProperty("lc_frequency", "", "lines")
    self.lc_frequency = [str(x) for x in range(0,24,3)]
    
    memberdata._setProperty('lc_notify_details', 'lc_status', 'multiple selection')
    memberdata._setProperty('lc_notify_frequency', 'lc_frequency', 'multiple selection')
    memberdata._setProperty('lc_notify_changes_only', '', 'boolean')
    memberdata._setProperty('lc_notify_last_notification', '2000/01/01',
                            'date')

    # Override actions for all supported default content types

    pfc = getToolByName(self, 'portal_form_controller')
    pfc.addFormAction('link_edit', 'success', ANY_CONTEXT, ANY_BUTTON, "traverse_to", "string:document_updatelinks")
    pfc.addFormAction('event_edit', 'success', ANY_CONTEXT, ANY_BUTTON, "traverse_to", "string:document_updatelinks")
    pfc.addFormAction('document_edit', 'success', ANY_CONTEXT, ANY_BUTTON, "traverse_to", "string:document_updatelinks")
    pfc.addFormAction('newsitem_edit', 'success', ANY_CONTEXT, ANY_BUTTON, "traverse_to", "string:document_updatelinks")

    print >> out, 'Successfully installed CMFLinkChecker'

    return out.getvalue()

def uninstall(self):
   portal_conf=getToolByName(self,'portal_controlpanel')
   portal_conf.unregisterConfiglet('CMFLinkChecker')
   portal_conf=getToolByName(self,'portal_controlpanel')
   portal_conf.unregisterConfiglet('MemberLinkChecker')

   portal_cat = getToolByName(self, 'portal_catalog')
   portal_cat.delIndex('portal_linkchecker_uid')

   portal_actions = getToolByName(self, 'portal_actions')
   portal_actions.manage_aproviders(chosen=('portal_linkchecker',), del_provider=1)
   
   memberdata = getToolByName(self, "portal_memberdata")
   memberdata._delProperty('lc_notify_details')
   memberdata._delProperty('lc_notify_frequency')
   memberdata._delProperty('lc_notify_changes_only')
   memberdata._delProperty('lc_notify_last_notification')

   self._delProperty('lc_status')
   self._delProperty('lc_frequency')

