##############################################################################
#
# Copyright (c) 2003 gocept gmbh & co. kg. All rights reserved.
#
# See also LICENSE
#
##############################################################################
"""ShortURL tests

$Id: test_shorturl.py,v 1.1 2004/06/28 19:40:25 ctheune Exp $"""

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

import unittest
from Testing import ZopeTestCase

from unittest import TestSuite, TestCase, makeSuite, main
from Products.CMFLinkChecker.shorturls import shortURL

class ShortURLTest(TestCase):

    def testNormal(self):
        url = "http://www.gocept.com"
        self.assertEqual(shortURL(url), url)

        url = "http://www.gocept.com/test"
        self.assertEqual(shortURL(url, len(url)), url)

        url = "http://www.gocept.com/test/test1/test2;parameter?query=1#fragment"
        self.assertEqual(shortURL(url, len(url)), url)

    def testPathFolding(self):

        url = "http://www.gocept.com/angebot/opensource/CMFLinkChecker/revision1.3"
        self.assertEqual(shortURL(url), "http://www.gocept.com/angebot/.../revision1.3")
        self.assertEqual(shortURL(url, 40), "http://www.gocept.com/.../revision1.3")

    def testPriorityFolding(self):

        url = "http://www.gocept.com/angebot/opensource/CMFLinkChecker/revision1.3;asdf?query=1#fragment"
        
        self.assertEqual(shortURL(url, 84), 
              "http://www.gocept.com/angebot/opensource/CMFLinkChecker/revision1.3;asdf?query=1#...")

        self.assertEqual(shortURL(url, 80), 
              "http://www.gocept.com/angebot/opensource/CMFLinkChecker/revision1.3;asdf?...#...")
        
        self.assertEqual(shortURL(url, 60), 
              "http://www.gocept.com/angebot/.../revision1.3;...?...#...")

if __name__ == '__main__':
    main()
