##############################################################################
#
# Copyright (c) 2003 gocept gmbh & co. kg. All rights reserved.
#
# See also LICENSE.txt
#
##############################################################################
"""CMF link checker tool - general utility functions

$Id: utils.py,v 1.3 2004/03/26 14:25:34 ctheune Exp $"""

# CMF/Plone imports
from Products.CMFCore.utils import getToolByName

# Python imports
from urlparse import urlparse

def url2dict(url):
    x = {}
    (x['scheme'], x['netloc'], x['path'], x['parameters'], x['query'], \
            x['fragment']) = urlparse(url)
    return x

def resolveRelativeLink(url, context):
    """Tries to canonize the given URL"""

    # Don't canonize mailto: links (maybe some others in future as well)
    url_ = url2dict(url)

    if url_['scheme'] in ['mailto',]:
        return url

    new_url = ""
    lc = getToolByName(context, "portal_linkchecker")
    if url_['scheme']:           # Ok, this is a complete URL
        new_url = url
    elif url_['netloc']:         # Hmm. There is a host. Let's use http.
        new_url = "http://" + url
    elif url_['path'].startswith('/'):  # Ok, that's hard. It's an absolute 
                                      # path, let's use the default prefix 
                                      # with scheme and netlocation
                                      # Otherwise the REQUEST information is fine.
        y = url2dict(lc.defaultURIPrefix)
        new_url = ((y['scheme']+"://" + y["netloc"]) or context.REQUEST.BASE0) + url
    else:                            # Ok, this path is relative, we just append either
                                     # the defaultURIPrefix or the REQUEST.BASE0 + the
                                     # current location. ".." are not resolved.
        new_url = (lc.defaultURIPrefix or context.REQUEST.BASE0) + "/".join(context.getPhysicalPath()[:-1]) + "/" + url
    return new_url
